org.apache.lucene.analysis.miscellaneous

## Class WordDelimiterFilter

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.TokenFilter
      - - org.apache.lucene.analysis.miscellaneous.WordDelimiterFilter

- All Implemented Interfaces:
    Closeable, AutoCloseable

  Deprecated.
  Use `WordDelimiterGraphFilter` instead: it produces a correct token graph so that e.g. `PhraseQuery` works correctly when it's used in the search time analyzer.

      @Deprecated
      public final class WordDelimiterFilter
      extends TokenFilter

  Splits words into subwords and performs optional transformations on subword groups. Words are split into subwords with the following rules:
  - split on intra-word delimiters (by default, all non alpha-numeric characters): `"Wi-Fi"` → `"Wi", "Fi"`
  - split on case transitions: `"PowerShot"` → `"Power", "Shot"`
  - split on letter-number transitions: `"SD500"` → `"SD", "500"`
  - leading and trailing intra-word delimiters on each subword are ignored: `"//hello---there, 'dude'"` → `"hello", "there", "dude"`
  - trailing "'s" are removed for each subword: `"O'Neil's"` → `"O", "Neil"`
    - Note: this step isn't performed in a separate filter because of possible subword combinations.
  The GENERATE... options affect how incoming tokens are broken into parts, and the various CATENATE_... parameters affect how those parts are combined.
  - If no CATENATE option is set, then no subword combinations are generated: `"PowerShot"` → `0:"Power", 1:"Shot"` (0 and 1 are the token positions)
  - CATENATE_WORDS means that in addition to the subwords, maximum runs of non-numeric subwords are catenated and produced at the same position of the last subword in the run:
    - `"PowerShot"` → `0:"Power", 1:"Shot" 1:"PowerShot"`
    - `"A's+B's&C's"` > `0:"A", 1:"B", 2:"C", 2:"ABC"`
    - `"Super-Duper-XL500-42-AutoCoder!"` → `0:"Super", 1:"Duper", 2:"XL", 2:"SuperDuperXL", 3:"500" 4:"42", 5:"Auto", 6:"Coder", 6:"AutoCoder"`
  - CATENATE_NUMBERS works like CATENATE_WORDS, but for adjacent digit sequences.
  - CATENATE_ALL smushes together all the token parts without distinguishing numbers and words.
  One use for `WordDelimiterFilter` is to help match words with different subword delimiters. For example, if the source text contained "wi-fi" one may want "wifi" "WiFi" "wi-fi" "wi+fi" queries to all match. One way of doing so is to specify CATENATE options in the analyzer used for indexing, and not in the analyzer used for querying. Given that the current `StandardTokenizer` immediately removes many intra-word delimiters, it is recommended that this filter be used after a tokenizer that does not do this (such as `WhitespaceTokenizer`).

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ALPHA` Deprecated.
    `static int` | `ALPHANUM` Deprecated.
    `static int` | `CATENATE_ALL` Deprecated. Causes all subword parts to be catenated:
    `static int` | `CATENATE_NUMBERS` Deprecated. Causes maximum runs of word parts to be catenated:
    `static int` | `CATENATE_WORDS` Deprecated. Causes maximum runs of word parts to be catenated:
    `static int` | `DIGIT` Deprecated.
    `static int` | `GENERATE_NUMBER_PARTS` Deprecated. Causes number subwords to be generated:
    `static int` | `GENERATE_WORD_PARTS` Deprecated. Causes parts of words to be generated:
    `static int` | `IGNORE_KEYWORDS` Deprecated. Suppresses processing terms with `KeywordAttribute.isKeyword()`=true.
    `static int` | `LOWER` Deprecated.
    `static int` | `PRESERVE_ORIGINAL` Deprecated. Causes original words are preserved and added to the subword list (Defaults to false)
    `static int` | `SPLIT_ON_CASE_CHANGE` Deprecated. If not set, causes case changes to be ignored (subwords will only be generated given SUBWORD_DELIM tokens)
    `static int` | `SPLIT_ON_NUMERICS` Deprecated. If not set, causes numeric changes to be ignored (subwords will only be generated given SUBWORD_DELIM tokens).
    `static int` | `STEM_ENGLISH_POSSESSIVE` Deprecated. Causes trailing "'s" to be removed for each subword
    `static int` | `SUBWORD_DELIM` Deprecated.
    `static int` | `UPPER` Deprecated.

    - ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

      `input`

    - ### Fields inherited from class org.apache.lucene.analysis.TokenStream

      `DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WordDelimiterFilter(TokenStream in, byte[] charTypeTable, int configurationFlags, CharArraySet protWords)` Deprecated. Creates a new WordDelimiterFilter
    `WordDelimiterFilter(TokenStream in, int configurationFlags, CharArraySet protWords)` Deprecated. Creates a new WordDelimiterFilter using `WordDelimiterIterator.DEFAULT_WORD_DELIM_TABLE` as its charTypeTable

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `incrementToken()` Deprecated.
    `void` | `reset()` Deprecated.

    - ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

      `close, end`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### LOWER

          public static final int LOWER

      Deprecated.
      See Also:
        Constant Field Values

    - #### UPPER

          public static final int UPPER

      Deprecated.
      See Also:
        Constant Field Values

    - #### DIGIT

          public static final int DIGIT

      Deprecated.
      See Also:
        Constant Field Values

    - #### SUBWORD_DELIM

          public static final int SUBWORD_DELIM

      Deprecated.
      See Also:
        Constant Field Values

    - #### ALPHA

          public static final int ALPHA

      Deprecated.
      See Also:
        Constant Field Values

    - #### ALPHANUM

          public static final int ALPHANUM

      Deprecated.
      See Also:
        Constant Field Values

    - #### GENERATE_WORD_PARTS

          public static final int GENERATE_WORD_PARTS

      Deprecated.
      Causes parts of words to be generated:

      "PowerShot" => "Power" "Shot"

      See Also:
        Constant Field Values

    - #### GENERATE_NUMBER_PARTS

          public static final int GENERATE_NUMBER_PARTS

      Deprecated.
      Causes number subwords to be generated:

      "500-42" => "500" "42"

      See Also:
        Constant Field Values

    - #### CATENATE_WORDS

          public static final int CATENATE_WORDS

      Deprecated.
      Causes maximum runs of word parts to be catenated:

      "wi-fi" => "wifi"

      See Also:
        Constant Field Values

    - #### CATENATE_NUMBERS

          public static final int CATENATE_NUMBERS

      Deprecated.
      Causes maximum runs of word parts to be catenated:

      "500-42" => "50042"

      See Also:
        Constant Field Values

    - #### CATENATE_ALL

          public static final int CATENATE_ALL

      Deprecated.
      Causes all subword parts to be catenated:

      "wi-fi-4000" => "wifi4000"

      See Also:
        Constant Field Values

    - #### PRESERVE_ORIGINAL

          public static final int PRESERVE_ORIGINAL

      Deprecated.
      Causes original words are preserved and added to the subword list (Defaults to false)

      "500-42" => "500" "42" "500-42"

      See Also:
        Constant Field Values

    - #### SPLIT_ON_CASE_CHANGE

          public static final int SPLIT_ON_CASE_CHANGE

      Deprecated.
      If not set, causes case changes to be ignored (subwords will only be generated given SUBWORD_DELIM tokens)
      See Also:
        Constant Field Values

    - #### SPLIT_ON_NUMERICS

          public static final int SPLIT_ON_NUMERICS

      Deprecated.
      If not set, causes numeric changes to be ignored (subwords will only be generated given SUBWORD_DELIM tokens).
      See Also:
        Constant Field Values

    - #### STEM_ENGLISH_POSSESSIVE

          public static final int STEM_ENGLISH_POSSESSIVE

      Deprecated.
      Causes trailing "'s" to be removed for each subword

      "O'Neil's" => "O", "Neil"

      See Also:
        Constant Field Values

    - #### IGNORE_KEYWORDS

          public static final int IGNORE_KEYWORDS

      Deprecated.
      Suppresses processing terms with `KeywordAttribute.isKeyword()`=true.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### WordDelimiterFilter

          public WordDelimiterFilter(TokenStream in,
                                     byte[] charTypeTable,
                                     int configurationFlags,
                                     CharArraySet protWords)

      Deprecated.
      Creates a new WordDelimiterFilter
      Parameters:
        `in` - TokenStream to be filtered
        `charTypeTable` - table containing character types
        `configurationFlags` - Flags configuring the filter
        `protWords` - If not null is the set of tokens to protect from being delimited

    - #### WordDelimiterFilter

          public WordDelimiterFilter(TokenStream in,
                                     int configurationFlags,
                                     CharArraySet protWords)

      Deprecated.
      Creates a new WordDelimiterFilter using `WordDelimiterIterator.DEFAULT_WORD_DELIM_TABLE` as its charTypeTable
      Parameters:
        `in` - TokenStream to be filtered
        `configurationFlags` - Flags configuring the filter
        `protWords` - If not null is the set of tokens to protect from being delimited

  - ### Method Detail

    - #### incrementToken

          public boolean incrementToken()
                                 throws IOException

      Deprecated.
      Specified by:
        `incrementToken` in class `TokenStream`
      Throws:
        `IOException`

    - #### reset

          public void reset()
                     throws IOException

      Deprecated.
      Overrides:
        `reset` in class `TokenFilter`
      Throws:
        `IOException`

Copyright © 2000-2024 Apache Software Foundation. All Rights Reserved.